//---------------------------------------------------------------------------
// Delphi / C++ Builder DFM and Kylix XPM file to FOX GUI Cpp converter
//
// 2001r. by Janusz Ganczarski (POWER)
//---------------------------------------------------------------------------
// history:
//---------------------------------------------------------------------------
/*
  15.05.2001 - get started !!! DFM -> CPP+H for FOX GUI;
  16.05.2001 - TForm;
  17.05.2001 - Font.Color and Color properties for TLabel;
  18.05.2001 - generate FXMainWindow or FXDialogBox class;
  19.05.2001 - TFont properties of TLabel; version 0.01.00;
  20.05.2001 - TForm: BorderIcons, BorderStyle; add TStaticText;
               TButton: Enabled
  21.05.2001 - TButton - Font; version 0.02.00;
  30.09.2001 - TForm - IconData with foxico.1.0.2 (included)
  03.10.2001 - added switches: -d, -m and error checking for file I/O;
               version 0.02.01
  06.10.2001 - change examles program for FOX-0.99.176 library version
               (ICO File I/O included)
  19.10.2001 - first step to event function support - OnClick from TButton
               class Evens support
  20.10.2001 - add TBitBtn + Glyph support; version 0.03.00
  21.10.2001 - add full support for Kind property from TBitBtn class;
               version 0.03.01;
  22.10.2001 - add TImage class support (currently BMP,ICO and JPEG image);
               version 0.04.00;
  23.10.2001 - add TImage Scale property
  24.10.2001 - add TImage Proportional property; version 0.04.1;
  25.10.2001 - add TImage support for EMF/WMF file (of course, no for display);
               version 0.04.2;
  28.10.2001 - add ModalResult for TButton class when generate FXDialogBox
               parent class; add -ico, -glyph and -picture switches;
               version 0.05;
  29.10.2001 - added -main switch for generate main function; version 0.06;
  03.11.2001 - ShowHint in TLabel
  04.11.2001 - added support for TCheckBox class; version 0.07;
  05.11.2001 - fixed problem wiht GCC compiler (function TBitBtnClass);
               first test with Kylix XFM files
  06.11.2001 - add support for TForm class events: OnMouseDown, OnMouseMove,
               OnMouseUp, OnClick, OnKeyDown, OnKeyPress, OnKeyUp, OnClose,
               OnPaint, OnResize; version 0.08;
  07.11.2001 - add support events OnMouseEnter, OnMouseLeave, OnMouseDown and
               OnMouseUp events for TLabel and TStaticText class; new test
               program for D6; version 0.08.1;
  08.11.2001 - add support for:
               - TStaticText: ShowHint
               - TGroupBox: Enabled, OnClick, OnMouseDown, OnMouseUp
               - TMainMenu class
               - TMenuItem: Caption, Enabled, OnClick
               add new test program for D6; version 0.09;
*/

/*
  Known bugs:
  - in D5 TForm.BorderStyle = bsDialog no generte close button?


*/

#include "src/dfmparser.cpp"

//---------------------------------------------------------------------------
// **************************************************************************
// under development!
// **************************************************************************
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// TMainMenu Class
//---------------------------------------------------------------------------

void DFMParser::TMainMenuClass ()
{
  MenuDepth = 0;

  // *.h file
  fprintf (hfile,"  FXMenubar *%s;\n",Stack -> Name);

  // *.cpp file
  fprintf (cppfile,"  %s = new FXMenubar(%s,LAYOUT_SIDE_TOP | LAYOUT_FILL_X);\n",Stack -> Name,Stack -> Next -> Name);

  // read words...
  bool Error;
  char *Name = ReadString (Error);
  while (Pos < TextSize)
    {

      // object
      if (strcmp (Name,"object") == 0)
        {
          // read class name
          char *ClassName = ReadString (Error);
          Push (Stack,ClassName);
          delete [] ClassName;
          SkipChar (':');

          // read TMenuItem
          ReadString (Error);

          // create TMenuItem
          TMenuItemClass ();
        }
      else

      // end
      if (strcmp (Name,"end") == 0)
        {
          // step down....
          MenuDepth--;
          if (MenuDepth < 0)
            break;
          else
            Pop (Stack);
        }

      // read new word ...
      delete [] Name;
      Name = ReadString (Error);
    }

  // one empty line
  fprintf (cppfile,"\n");
}

//---------------------------------------------------------------------------
// TMenuItem Class
//---------------------------------------------------------------------------

void DFMParser::TMenuItemClass ()
{
  MenuDepth++;

  // properties
  char *Caption = NULL;
  char *Enabled = NULL;

  // events
  char *OnClick = NULL;

  // read words...
  bool Error;
  char *Name = ReadString (Error);
  while (strcmp (Name,"object") != 0 && strcmp (Name,"end") != 0)
    {
      // Caption
      ReadQuotationProperty (Name,"Caption",Caption);

      // Enabled
      ReadStringProperty (Name,"Enabled",Enabled);

      // OnClick
      ReadStringProperty (Name,"OnClick",OnClick);

      // read new word ...
      delete [] Name;
      Name = ReadString (Error);
    }

  if (MenuDepth == 1)
    {
      // *.h file
      fprintf (hfile,"  FXMenuPane *%sPane;\n",Stack -> Name);
      fprintf (hfile,"  FXMenuTitle *%s;\n",Stack -> Name);

      // *.cpp file
      fprintf (cppfile,"  %sPane = new FXMenuPane (this);\n",Stack -> Name);
      fprintf (cppfile,"  %s = new FXMenuTitle (%s,\"%s\",NULL,%sPane);\n",Stack -> Name,Stack -> Next -> Name,Caption,Stack -> Name);
/*
      // Event - OnClick
      if (OnClick != NULL)
        {
          // EventFunction
          Push (EventsFunction,OnClick);

          // Message Type
          Push (MessageType,"SEL_LEFTBUTTONPRESS");//SEL_COMMAND");

          // MessageID
          char MsgID [512];
          sprintf (MsgID,"ID_%s",Stack -> Name);
          Push (MessageID,MsgID);
        }

      // any Event
      if (OnClick != NULL)
        {
          // MessageID
          char MsgID [512];
          sprintf (MsgID,"ID_%s",Stack -> Name);

          // select Target and Selector
          fprintf (cppfile,"  %s -> setTarget (this);\n",Stack -> Name);
          fprintf (cppfile,"  %s -> setSelector (%s);\n",Stack -> Name,MsgID);
        }
*/
      // Enabled
      if (Enabled != NULL && strcmp (Enabled,"False") == 0)
        {
           fprintf (cppfile,"  %s -> disable ();\n",Stack -> Name);
        }
    }
  else

  if (MenuDepth == 2)
    {
      // Caption
      if (Caption == NULL)
        {
          // *.h file
          fprintf (hfile,"  FXMenuCommand *%s;\n",Stack -> Name);

          // OnClick
          if (OnClick != NULL)
            fprintf (cppfile,"  %s = new FXMenuCommand (%sPane,\" \",NULL,this,ID_%s);\n",Stack -> Name,Stack -> Next -> Name,Stack -> Name);
          else
            fprintf (cppfile,"  %s = new FXMenuCommand (%sPane,\" \",NULL,NULL,0);\n",Stack -> Name,Stack -> Next -> Name);
        }
      else

      // Caption '-' - separator
      if (strcmp (Caption,"-") == 0)
        {
          // *.h file
          fprintf (cppfile,"  FXMenuSeparator *%s;\n",Stack -> Name);

          // *.cpp file
          fprintf (cppfile,"  %s = new FXMenuSeparator (%sPane);\n",Stack -> Name,Stack -> Next -> Name);
        }
      else
        {
          // *.h file
          fprintf (hfile,"  FXMenuCommand *%s;\n",Stack -> Name);

          // OnClick
          if (OnClick != NULL)
            fprintf (cppfile,"  %s = new FXMenuCommand (%sPane,\"%s\",NULL,this,ID_%s);\n",Stack -> Name,Stack -> Next -> Name,Caption,Stack -> Name);
          else
            fprintf (cppfile,"  %s = new FXMenuCommand (%sPane,\"%s\",NULL,NULL,0);\n",Stack -> Name,Stack -> Next -> Name,Caption);
        }

      // Event - OnClick
      if (OnClick != NULL)
        {
          // EventFunction
          Push (EventsFunction,OnClick);

          // Message Type
          Push (MessageType,"SEL_COMMAND");

          // MessageID
          char MsgID [512];
          sprintf (MsgID,"ID_%s",Stack -> Name);
          Push (MessageID,MsgID);
        }

      // Enabled
      if (Enabled != NULL && strcmp (Enabled,"False") == 0)
        {
           fprintf (cppfile,"  %s -> disable ();\n",Stack -> Name);
        }
    }

  // one empty line
  fprintf (cppfile,"\n");

  if (strcmp (Name,"end") == 0)
    {
      MenuDepth--;
      Pop (Stack);
    }
  else

  // restore for 'object'...
  if (strcmp (Name,"object") == 0)
    Pos -= 6;

  // clear
  delete [] Name;
  delete [] Caption;
  delete [] OnClick;
}


//---------------------------------------------------------------------------
// version
//---------------------------------------------------------------------------

#define Version "0.09"
  

//---------------------------------------------------------------------------
// printing information about program
//---------------------------------------------------------------------------

void PrintInfo ()
{
  printf ("DFM/XPM to FOX CPP File Converter Saver Version %s\n",Version);
  printf ("Copyright (C) 2001 by Janusz Ganczarski (POWER)\n");
  printf ("\nUsage: dfm2cpp file.txt [-d][-m][-ico][-glyph][-picture][-main]\n");
  printf ("         file.txt - only text version of DFM file\n");
  printf ("                    (please use convert.exe utility from Borland)\n");
  printf ("\n");
  printf ("Switches:\n");
  printf ("  -d create FXDialogBox parent class (default)\n");
  printf ("  -m create FXMainWindow parent class\n");
  printf ("  -ico save icon file(s)\n");
  printf ("  -glyph save glyph file(s)\n");
  printf ("  -picture save picture file(s)\n");
  printf ("  -picture save picture file(s)\n");
  printf ("  -main create main function\n");
}

//---------------------------------------------------------------------------
// main
//---------------------------------------------------------------------------

int main (int argc, char **argv)
{
  // checking for parameters
  if (argc < 2)
    {
      PrintInfo ();
      return 1;
    }

  // create and run parser
  try
  {
    // create parser
    DFMParser Parser (argv [1]);

    // check for command line parameters
    for (int i = 2; i < argc; i++)
      {
        // -d switch: create the FXDialogbox
        if (strcmp (argv [i],"-d") == 0)
          Parser.SetClassGenerateType (DIALOG_BOX);

        // -m switch: create the FXMainWindow
        if (strcmp (argv [i],"-m") == 0)
          Parser.SetClassGenerateType (MAIN_WINDOW);

        // -ico switch: save icon file(s)
        if (strcmp (argv [i],"-ico") == 0)
          Parser.SetSaveICO (true);

        // -glyph switch: save glyph file(s)
        if (strcmp (argv [i],"-glyph") == 0)
          Parser.SetSaveGlyph (true);

        // -picture switch: save picture file(s)
        if (strcmp (argv [i],"-picture") == 0)
          Parser.SetSavePicture (true);

        // -picture switch: save picture file(s)
        if (strcmp (argv [i],"-main") == 0)
          Parser.SetGenerateMain (true);
      }

    // parse file
    Parser.ParseFile ();
  }

  catch (DFMParser_Exception Excep)
    {
      switch (Excep)
        {
          case DFM_PARSER_ERROR_OPEN_FILE:
            printf ("Error open file: %s\n",argv [1]);
            return 1;
          case DFM_PARSER_ERROR_READ_FILE:
            printf ("Error read file: %s\n",argv [1]);
            return 1;
          /*
          case DFM_PARSER_ERROR_WRITE_FILE:
            printf ("Error write file: %s\n",argv [1]);
            return 1;
          */
        }
    }

  return 0;
}
//---------------------------------------------------------------------------

