#ifndef __STACK_H__
#define __STACK_H__

//---------------------------------------------------------------------------
// element of stack
//---------------------------------------------------------------------------

struct StackElement
{
  char Name [256];
  struct StackElement *Next;
};

//---------------------------------------------------------------------------
// is stack empty?
//---------------------------------------------------------------------------

inline bool Empty (StackElement *Stack)
{
  return Stack == NULL;
}

//---------------------------------------------------------------------------
// add element to stack
//---------------------------------------------------------------------------

inline void Push (StackElement *&Stack,char *NewName)
{
  StackElement *NewElement = new StackElement ();
  strncpy (NewElement -> Name,NewName,255);
  NewElement -> Next  = Stack;
  Stack = NewElement;
}

//---------------------------------------------------------------------------
// remove element from stack
//---------------------------------------------------------------------------

inline StackElement *Pop (StackElement *&Stack)
{
  static StackElement TmpStackElement;
  TmpStackElement = *Stack;
  StackElement *TmpStack = Stack -> Next;
  delete Stack;
  Stack = TmpStack;
  return &TmpStackElement;
}

//---------------------------------------------------------------------------
// search for stack elememet
//---------------------------------------------------------------------------

inline bool Search (StackElement *Stack,char *Name)
{
  while (Stack)
    if (strcmp (Name,Stack -> Name) == 0)
      return true;
    else
      Stack = Stack -> Next;
  return false;
}

//---------------------------------------------------------------------------
// reverse stack elements
//---------------------------------------------------------------------------

inline StackElement *Reverse (StackElement *&Stack)
{
  StackElement *ReverseStack = NULL;
  while (Stack != NULL)
    {
      Push (ReverseStack,Stack -> Name);
      Pop (Stack);
    }
  Stack = ReverseStack;
  return Stack;
}

//---------------------------------------------------------------------------
// get first element
//---------------------------------------------------------------------------

inline StackElement *First (StackElement *Stack)
{
  static StackElement TmpStackElement;
  if (Stack == NULL)
    return NULL;
  while (Stack -> Next != NULL)
    {
      Stack = Stack -> Next;
    }
  TmpStackElement = *Stack;
  return &TmpStackElement;
}

#endif // __STACK_H__
