//---------------------------------------------------------------------------
// TBevel Class
//---------------------------------------------------------------------------

void DFMParser::TBevelClass ()
{
  // attributes
  int  Left;
  int  Top;
  int  Width;
  int  Height;
  char *Style = NULL;
  char *Shape = NULL;

  // read words...
  bool Error;
  char *Name = ReadString (Error);
  while (strcmp (Name,"object") != 0 && strcmp (Name,"end") != 0)
    {
      // Left
      if (strcmp (Name,"Left") == 0)
        {
          SkipChar ('=');
          Left = ReadDigit (Error);
        }
      else

      // Top
      if (strcmp (Name,"Top") == 0)
        {
          SkipChar ('=');
          Top = ReadDigit (Error);
        }
      else

      // Height
      if (strcmp (Name,"Height") == 0)
        {
          SkipChar ('=');
          Height = ReadDigit (Error);
        }
      else

      // Width
      if (strcmp (Name,"Width") == 0)
        {
          SkipChar ('=');
          Width = ReadDigit (Error);
        }
      else

      // Style
      if (strcmp (Name,"Style") == 0)
        {
          SkipChar ('=');
          Style = ReadString (Error);
        }
      else

      // Shape
      if (strcmp (Name,"Shape") == 0)
        {
          SkipChar ('=');
          Shape = ReadString (Error);
        }

      // read new word ...
      delete [] Name;
      Name = ReadString (Error);
    }
  delete [] Name;

  // *.cpp file
/*
  FRAME_NONE   = 0,                                     /// Default is no frame
  FRAME_SUNKEN = 0x00001000,                            /// Sunken border
  FRAME_RAISED = 0x00002000,                            /// Raised border
  FRAME_THICK  = 0x00004000,                            /// Thick border
  FRAME_GROOVE = FRAME_THICK,                           /// A groove or etched-in border
  FRAME_RIDGE  = FRAME_THICK|FRAME_RAISED|FRAME_SUNKEN, /// A ridge or embossed border
  FRAME_LINE   = FRAME_RAISED|FRAME_SUNKEN,             /// Simple line border
  FRAME_NORMAL = FRAME_SUNKEN|FRAME_THICK               /// Regular raised/thick border
*/
//FRAME_SUNKEN - ramka wklsa

/*
Set Shape to specify whether the bevel appears as a line, box, frame, or space. These are the possible values of Shape:
bsBox	The entire client area appears raised or lowered, depending on the value of Style.
bsFrame	The client area is outlined by a raised or lowered frame.
bsTopLine	The bevel displays a line at the top of the client area.
bsBottomLine	The bevel displays a line at the bottom of the client area.
bsLeftLine	The bevel displays a line at the left side of the client area.
bsRightLine	The bevel displays a line at the right side of the client area.
bsSpacer	The bevel is an empty space.
*/

  // bsBox - default
  if (Shape == NULL || strcmp (Shape,"bsBox") == 0)
    {
    }
  else

  // bsFrame
  if (strcmp (Shape,"bsFrame") == 0)
    {
      // *.h file
      fprintf (hfile,"  FXFrame *%s_top;\n",Stack -> Name);
      fprintf (hfile,"  FXFrame *%s_bottom;\n",Stack -> Name);
      fprintf (hfile,"  FXFrame *%s_left;\n",Stack -> Name);
      fprintf (hfile,"  FXFrame *%s_right;\n",Stack -> Name);

      // *.cpp file

      // Top Line
      fprintf (cppfile,"  %s_top = new FXFrame (%s,LAYOUT_FIX_X | LAYOUT_FIX_Y | LAYOUT_FIX_WIDTH | LAYOUT_FIX_HEIGHT",
        Stack -> Name,Stack -> Next -> Name);

      // Style
      if (Style == NULL || strcmp (Style,"bsLowered") == 0)
        fprintf (cppfile," | FRAME_SUNKEN");
      else
        fprintf (cppfile," | FRAME_RAISED");
      fprintf (cppfile,",%i,%i,%i,%i,0,0,0,0);\n",Left,Top,Width,2);

      // Bottom Line
      fprintf (cppfile,"  %s_bottom = new FXFrame (%s,LAYOUT_FIX_X | LAYOUT_FIX_Y | LAYOUT_FIX_WIDTH | LAYOUT_FIX_HEIGHT",
        Stack -> Name,Stack -> Next -> Name);

      // Style
      if (Style == NULL || strcmp (Style,"bsLowered") == 0)
        fprintf (cppfile," | FRAME_SUNKEN");
      else
        fprintf (cppfile," | FRAME_RAISED");
      fprintf (cppfile,",%i,%i,%i,%i,0,0,0,0);\n",Left,Top + Height - 2,Width,2);

      // Left Line
      fprintf (cppfile,"  %s_left = new FXFrame (%s,LAYOUT_FIX_X | LAYOUT_FIX_Y | LAYOUT_FIX_WIDTH | LAYOUT_FIX_HEIGHT",
        Stack -> Name,Stack -> Next -> Name);

      // Style
      if (Style == NULL || strcmp (Style,"bsLowered") == 0)
        fprintf (cppfile," | FRAME_SUNKEN");
      else
        fprintf (cppfile," | FRAME_RAISED");
      fprintf (cppfile,",%i,%i,%i,%i,0,0,0,0);\n",Left,Top,2,Height);

      // Right Line
      fprintf (cppfile,"  %s_right = new FXFrame (%s,LAYOUT_FIX_X | LAYOUT_FIX_Y | LAYOUT_FIX_WIDTH | LAYOUT_FIX_HEIGHT",
        Stack -> Name,Stack -> Next -> Name);

      // Style
      if (Style == NULL || strcmp (Style,"bsLowered") == 0)
        fprintf (cppfile," | FRAME_SUNKEN");
      else
        fprintf (cppfile," | FRAME_RAISED");
      fprintf (cppfile,",%i,%i,%i,%i,0,0,0,0);\n",Left + Width - 2,Top+1,2,Height-2);
    }
  else

  // bsTopLine
  if (strcmp (Shape,"bsTopLine") == 0)
    {
      // *.h file
      fprintf (hfile,"  FXFrame *%s;\n",Stack -> Name);

      // *.cpp file
      fprintf (cppfile,"  %s = new FXFrame (%s,LAYOUT_FIX_X | LAYOUT_FIX_Y | LAYOUT_FIX_WIDTH | LAYOUT_FIX_HEIGHT",
        Stack -> Name,Stack -> Next -> Name);

      // Style
      if (Style == NULL || strcmp (Style,"bsLowered") == 0)
        fprintf (cppfile," | FRAME_SUNKEN");
      else
        fprintf (cppfile," | FRAME_RAISED");
      fprintf (cppfile,",%i,%i,%i,%i,0,0,0,0);\n",Left,Top,Width,2);
    }
  else

  // bsBottomLine
  if (strcmp (Shape,"bsBottomLine") == 0)
    {
      // *.h file
      fprintf (hfile,"  FXFrame *%s;\n",Stack -> Name);

      // *.cpp file
      fprintf (cppfile,"  %s = new FXFrame (%s,LAYOUT_FIX_X | LAYOUT_FIX_Y | LAYOUT_FIX_WIDTH | LAYOUT_FIX_HEIGHT",
        Stack -> Name,Stack -> Next -> Name);

      // Style
      if (Style == NULL || strcmp (Style,"bsLowered") == 0)
        fprintf (cppfile," | FRAME_SUNKEN");
      else
        fprintf (cppfile," | FRAME_RAISED");
      fprintf (cppfile,",%i,%i,%i,%i,0,0,0,0);\n",Left,Top + Height - 2,Width,2);
    }
  else

  // bsLeftLine
  if (strcmp (Shape,"bsLeftLine") == 0)
    {
      // *.h file
      fprintf (hfile,"  FXFrame *%s;\n",Stack -> Name);

      // *.cpp file
      fprintf (cppfile,"  %s = new FXFrame (%s,LAYOUT_FIX_X | LAYOUT_FIX_Y | LAYOUT_FIX_WIDTH | LAYOUT_FIX_HEIGHT",
        Stack -> Name,Stack -> Next -> Name);

      // Style
      if (Style == NULL || strcmp (Style,"bsLowered") == 0)
        fprintf (cppfile," | FRAME_SUNKEN");
      else
        fprintf (cppfile," | FRAME_RAISED");
      fprintf (cppfile,",%i,%i,%i,%i,0,0,0,0);\n",Left,Top,2,Height);
    }
  else

  // bsRightLine
  if (strcmp (Shape,"bsRightLine") == 0)
    {
      // *.h file
      fprintf (hfile,"  FXFrame *%s;\n",Stack -> Name);

      // *.cpp file
      fprintf (cppfile,"  %s = new FXFrame (%s,LAYOUT_FIX_X | LAYOUT_FIX_Y | LAYOUT_FIX_WIDTH | LAYOUT_FIX_HEIGHT",
        Stack -> Name,Stack -> Next -> Name);

      // Style
      if (Style == NULL || strcmp (Style,"bsLowered") == 0)
        fprintf (cppfile," | FRAME_SUNKEN");
      else
        fprintf (cppfile," | FRAME_RAISED");
      fprintf (cppfile,",%i,%i,%i,%i,0,0,0,0);\n",Left + Width - 2,Top,2,Height);
    }

  // clear
  delete [] Style;
  delete [] Shape;
}
