//---------------------------------------------------------------------------
// TBitBtn Class
//---------------------------------------------------------------------------

/*
Supported Properties:

  Left
  Top
  Width
  Height
  Caption
  Hint
  Enabled
  Font.Color
  Font.Charset
  Font.Height
  Font.Name
  Font.Style
  Cursor
  Glyph.Data
  Layout
  Kind

Supported Events:
  OnClick
  OnKeyDown
  OnKeyUp

*/

void DFMParser::TBitBtnClass ()
{
  // properties
  int  Left;
  int  Top;
  int  Width;
  int  Height;
  char *Caption = NULL;
  char *Hint = NULL;
  char *Enabled = NULL;
  char *FontColor = NULL;
  char *FontCharset = NULL;
  int FontHeight = 0;
  char *FontName = NULL;
  StackElement *FontStyle = NULL;
  char *Cursor = NULL;
  char *GlyphData = NULL;
  char *Layout = NULL;
  char *Kind = NULL;

  // Events
  char *OnClick = NULL;
  char *OnKeyDown = NULL;
  char *OnKeyUp = NULL;

  // read words...
  bool Error;
  char *Name = ReadString (Error);
  while (strcmp (Name,"object") != 0 && strcmp (Name,"end") != 0)
    {
      // Left
      if (strcmp (Name,"Left") == 0)
        {
          SkipChar ('=');
          Left = ReadDigit (Error);
        }
      else

      // Top
      if (strcmp (Name,"Top") == 0)
        {
          SkipChar ('=');
          Top = ReadDigit (Error);
        }
      else

      // Height
      if (strcmp (Name,"Height") == 0)
        {
          SkipChar ('=');
          Height = ReadDigit (Error);
        }
      else

      // Width
      if (strcmp (Name,"Width") == 0)
        {
          SkipChar ('=');
          Width = ReadDigit (Error);
        }
      else

      // Caption
      if (strcmp (Name,"Caption") == 0)
        {
          SkipChar ('=');
          Caption = ReadQuotation (Error);
        }
      else

      // Hint
      if (strcmp (Name,"Hint") == 0)
        {
          SkipChar ('=');
          Hint = ReadQuotation (Error);
        }
      else

      // Enabled
      if (strcmp (Name,"Enabled") == 0)
        {
          SkipChar ('=');
          Enabled = ReadString (Error);
        }
      else

      // Font Charset
      if (strcmp (Name,"Font.Charset") == 0)
        {
          SkipChar ('=');
          FontCharset = ReadString (Error);
        }
      else

      // Font Height
      if (strcmp (Name,"Font.Height") == 0)
        {
          SkipChar ('=');
          FontHeight = ReadDigit (Error);
        }
      else

      // Font Name
      if (strcmp (Name,"Font.Name") == 0)
        {
          SkipChar ('=');
          FontName = ReadQuotation (Error);
        }
      else

      // Font Color
      if (strcmp (Name,"Font.Color") == 0)
        {
          SkipChar ('=');
          FontColor = ReadString (Error);
        }
      else

      // Font Style
      if (strcmp (Name,"Font.Style") == 0)
        {
          SkipChar ('=');
          SkipChar ('[');
          char *Style = NULL;
          while (TextBuf [Pos] != ']')
            {
              Style = ReadString (Error);
              Push (FontStyle,Style);
              delete [] Style;
            }
        }
      else

      // Cursor
      if (strcmp (Name,"Cursor") == 0)
        {
          SkipChar ('=');
          Cursor = ReadString (Error);
        }
      else

      // Glyph.Data
      if (strcmp (Name,"Glyph.Data") == 0)
        {
          SkipChar ('=');
          GlyphData = ReadIcon (Error);
        }

      // OnClick
      if (strcmp (Name,"OnClick") == 0)
        {
          SkipChar ('=');
          OnClick = ReadString (Error);
        }
      else

      // OnKeyDown
      if (strcmp (Name,"OnKeyDown") == 0)
        {
          SkipChar ('=');
          OnKeyDown = ReadString (Error);
        }
      else

      // OnKeyUp
      if (strcmp (Name,"OnKeyUp") == 0)
        {
          SkipChar ('=');
          OnKeyUp = ReadString (Error);
        }
      else

      // Layout
      if (strcmp (Name,"Layout") == 0)
        {
          SkipChar ('=');
          Layout = ReadString (Error);
        }
      else

      // Kind
      if (strcmp (Name,"Kind") == 0)
        {
          SkipChar ('=');
          Kind = ReadString (Error);
        }

      // read new word ...
      delete [] Name;
      Name = ReadString (Error);
    }
  delete [] Name;

  // *.h file
  fprintf (hfile,"  FXButton *%s;\n",Stack -> Name);

  // Glyph
  if (GlyphData != NULL)

    {

      // next Glyph file...

      GlyphCount++;

      char name [30];


      // write data

      sprintf (name,"glyph%i",GlyphCount);

      fprintf (cppfile,"  const unsigned char %s []={\n",name);

      fprintf (cppfile,"  ");

      int x = 0;


      // first 4 bytes (8 chars) is added (who know why?), next bytes creates a BMP file

      for (unsigned int i = 8; i < strlen (GlyphData); i += 2)

        {

          fprintf (cppfile,"0x%c%c",GlyphData [i],GlyphData [i+1]);

          if (i < strlen (GlyphData) - 2)

            fprintf (cppfile,",");

          else

            fprintf (cppfile,"};\n");

          if (++x == 16)

            {

              fprintf (cppfile,"\n  ");

              x = 0;

            }

        }

      fprintf (cppfile,"\n");


      // save the glyph file

      if (SaveGlyph == true)

        {

          strcat (name,".bmp");

          SaveIconGlyphFile (name,&GlyphData[8]);

        }

    }

  else

  // Kind
  if (Kind != NULL && strcmp (Kind,"bkCustom") != 0)
    {
      char GlyphAbortCancel []={
        "424D4E01000000000000760000002800000012000000120000000100040000000000D800000000000000000000000000"
        "00001000000000000000000080000080000000808000800000008000800080800000C0C0C000808080000000FF0000FF"
        "000000FFFF00FF000000FF00FF00FFFF0000FFFFFF003333333333333333330000003333883333333333330000003339"
        "118333339833330000003339111833391183330000003339111183911118330000003333911118111118330000003333"
        "391111111183330000003333339111111833330000003333333111118333330000003333333911118333330000003333"
        "339111118333330000003333391118111833330000003333911183911183330000003333911833391118330000003333"
        "39133333911133000000333333333333391933000000333333333333333333000000333333333333333333000000"};

      char GlyphAll[]={
        "424D5A01000000000000760000002800000012000000130000000100040000000000E400000000000000000000000000"
        "00001000000000000000000080000080000000808000800000008000800080800000C0C0C000808080000000FF0000FF"
        "000000FFFF00FF000000FF00FF00FFFF0000FFFFFF003333344333333333330000003333422433333333330000003334"
        "2222433333333300000033422222243333333300000034222A2222433333330000003222A2A222433333330000003A2A"
        "222A222433333300000034A22222A2224333330000004222A2222A22243333000000222A3A2224A2224333000000A2A3"
        "33A2224A2224330000003A33333A2224A2224300000033333333A2224A2243000000333333333A2224A2230000003333"
        "333333A2224A3300000033333333333A222433000000333333333333A224330000003333333333333A22330000003333"
        "3333333333A333000000"};

      char GlyphClose[]={
        "424D4E01000000000000760000002800000012000000120000000100040000000000D800000000000000000000000000"
        "00001000000000000000000080000080000000808000800000008000800080800000C0C0C000808080000000FF0000FF"
        "000000FFFF00FF000000FF00FF00FFFF0000FFFFFF00388888888877F7F7870000004444400888FFF444440000003333"
        "4D5007FFF43333000000333345D50FFFF4333300000033334D5D0FFFF43333000000333345D50FEFE433330000003333"
        "4D5D0FFFF43333000000333345D50FEFE4333300000033334D5D0FFFF43333000000333345D50FEFE433330000003333"
        "4D5D0EFEF43333000000333345D50FEFE4333300000033334D5D0EFEF433330000003333444444444433330000003333"
        "333333333333330000003333330000003333330000003333330AAAA0333333000000333333000000333333000000"};

      char GlyphHelp[]={
        "424D4E01000000000000760000002800000012000000120000000100040000000000D800000000000000000000000000"
        "00001000000000000000000080000080000000808000800000008000800080800000C0C0C000808080000000FF0000FF"
        "000000FFFF00FF000000FF00FF00FFFF0000FFFFFF003333333366333333330000003333333644633333330000003333"
        "333E664333333300000033333333E6633333330000003333333333333333330000003333333344633333330000003333"
        "333666433333330000003333333E66433333330000003333333E666433333300000033333333E6664333330000003333"
        "33333E666433330000003333344333E666433300000033336664333E6643330000003333E66644466643330000003333"
        "3E666666666333000000333333EE666666333300000033333333EEEEE33333000000333333333333333333000000"};

      char GlyphIgnore[]={
        "424D4E01000000000000760000002800000012000000120000000100040000000000D800000000000000000000000000"
        "00001000000000000000000080000080000000808000800000008000800080800000C0C0C000808080000000FF0000FF"
        "000000FFFF00FF000000FF00FF00FFFF0000FFFFFF0034444633333444433300000033AAA43333332A43330000003332"
        "A46333332A43330000003332A2433336A663330000003333AA463362A4333300000033336AA4462A4633330000003333"
        "32AA22246333330000003333336AAA2264633300000033444466AA436A4333000000336AA246A2436A43330000003333"
        "6A24AA442A4333000000333333A2AA2AA43333000000333333322AAA4333330000003333333322A43333330000003333"
        "33344A4333333300000033333336A24333333300000033333336AA43333333000000333333336663333333000000"};

      char GlyphNo[]={
        "424D4E01000000000000760000002800000012000000120000000100040000000000D800000000000000000000000000"
        "00001000000000000000000080000080000000808000800000008000800080800000C0C0C000808080000000FF0000FF"
        "000000FFFF00FF000000FF00FF00FFFF0000FFFFFF003333333333333333330000003333338888883333330000003333"
        "881111118833330000003338111999911183330000003391199333311118330000003391133333811118330000003911"
        "833338111911830000003918333381119391830000003918333811193391830000003918338111933391830000003918"
        "381119333391830000003911811193333911830000003391111933333918330000003391118333381118330000003339"
        "11188881118333000000333399111111993333000000333333999999333333000000333333333333333333000000"};

      char GlyphOkYes[]={
        "424D4E01000000000000760000002800000012000000120000000100040000000000D800000000000000000000000000"
        "00001000000000000000000080000080000000808000800000008000800080800000C0C0C000808080000000FF0000FF"
        "000000FFFF00FF000000FF00FF00FFFF0000FFFFFF003333333333333333330000003333333333333333330000003333"
        "344333333333330000003333422433333333330000003334222243333333330000003342222224333333330000003422"
        "2A2222433333330000003222A3A222433333330000003A2A333A222433333300000033A33333A2224333330000003333"
        "33333A222433330000003333333333A222433300000033333333333A222433000000333333333333A222430000003333"
        "333333333A224300000033333333333333A223000000333333333333333A33000000333333333333333333000000"};

      char GlyphRetry[]={
        "424D4E01000000000000760000002800000012000000120000000100040000000000D800000000000000000000000000"
        "00001000000000000000000080000080000000808000800000008000800080800000C0C0C000808080000000FF0000FF"
        "000000FFFF00FF000000FF00FF00FFFF0000FFFFFF003333334444443333330000003243342222224433330000003224"
        "422222222243330000003222222AAAAA222433000000322222A33333A222430000003222223333333A22430000003222"
        "222333333A44430000003AAAAAAA33333333330000003333333333333333330000003333333333334444440000003A44"
        "4333333A2222240000003A2243333333A2222400000033A22433333442222400000033A222444442222224000000333A"
        "2222222222AA240000003333AA222222AA33A3000000333333AAAAAA333333000000333333333333333333000000"};

      // select Glyph
      char *GlyphData;
      if (strcmp (Kind,"bkAbort") == 0 || strcmp (Kind,"bkCancel") == 0)
        GlyphData = GlyphAbortCancel;
      else
      if (strcmp (Kind,"bkAll") == 0)
        GlyphData = GlyphAll;
      else
      if (strcmp (Kind,"bkClose") == 0)
        GlyphData = GlyphClose;
      else
      if (strcmp (Kind,"bkHelp") == 0)
        GlyphData = GlyphHelp;
      else
      if (strcmp (Kind,"bkIgnore") == 0)
        GlyphData = GlyphIgnore;
      else
      if (strcmp (Kind,"bkNo") == 0)
        GlyphData = GlyphNo;
      else
      if (strcmp (Kind,"bkOK") == 0 || strcmp (Kind,"bkYes") == 0)
        GlyphData = GlyphOkYes;
      else
      if (strcmp (Kind,"bkRetry") == 0)
        GlyphData = GlyphRetry;

      // next Glyph file...
      GlyphCount++;

      char name [30];


      // write data

      sprintf (name,"glyph%i",GlyphCount);

      fprintf (cppfile,"  const unsigned char %s []={\n",name);

      fprintf (cppfile,"  ");

      int x = 0;


      for (unsigned int i = 0; i < strlen (GlyphData); i += 2)

        {

          fprintf (cppfile,"0x%c%c",GlyphData [i],GlyphData [i+1]);

          if (i < strlen (GlyphData) - 2)

            fprintf (cppfile,",");

          else

            fprintf (cppfile,"};\n");

          if (++x == 16)

            {

              fprintf (cppfile,"\n  ");

              x = 0;

            }

        }

      fprintf (cppfile,"\n");


      // save the glyph file

      strcat (name,".bmp");

      SaveIconGlyphFile (name,GlyphData);

    }

  // *.cpp file
  fprintf (cppfile,"  %s = new FXButton (%s,\"",Stack -> Name,Stack -> Next -> Name);

  // Caption
  if (Caption != NULL)
    {
      fprintf (cppfile,"%s",Caption);
    }
  else
  if (Kind != NULL && strcmp (Kind,"bkCustom") != 0)
    {
      if (strcmp (Kind,"bkAbort") == 0)
        fprintf (cppfile,"Abort");
      else
      if (strcmp (Kind,"bkCancel") == 0)
        fprintf (cppfile,"Cancel");
      else
      if (strcmp (Kind,"bkAll") == 0)
        fprintf (cppfile,"All");
      else
      if (strcmp (Kind,"bkClose") == 0)
        fprintf (cppfile,"Close");
      else
      if (strcmp (Kind,"bkHelp") == 0)
        fprintf (cppfile,"Help");
      else
      if (strcmp (Kind,"bkIgnore") == 0)
        fprintf (cppfile,"Ignore");
      else
      if (strcmp (Kind,"bkNo") == 0)
        fprintf (cppfile,"No");
      else
      if (strcmp (Kind,"bkOK") == 0)
        fprintf (cppfile,"OK");
      else
      if (strcmp (Kind,"bkYes") == 0)
        fprintf (cppfile,"Yes");
      else
      if (strcmp (Kind,"bkRetry") == 0)
        fprintf (cppfile,"Retry");
    }

  // Hint
  if (Hint != NULL)
    {
      fprintf (cppfile,"\\t%s",Hint);
    }

  // Glyph
  if (GlyphData != NULL)
    {
      char name [30];
      sprintf (name,"glyph%i",GlyphCount);

      fprintf (cppfile,"\",new FXBMPIcon(getApp(),%s,0,IMAGE_ALPHAGUESS)",name);
    }
  else
  if (Kind != NULL && strcmp (Kind,"bkCustom") != 0)
    {
      char name [30];
      sprintf (name,"glyph%i",GlyphCount);

      fprintf (cppfile,"\",new FXBMPIcon(getApp(),%s,0,IMAGE_ALPHAGUESS)",name);
    }
  else
    fprintf (cppfile,"\",NULL");

  // Event - OnClick, OnKeyDown or OnKeyUp
  if (OnClick != NULL || OnKeyDown != NULL || OnKeyUp != NULL)
    {
      fprintf (cppfile,",this,ID_%s",Stack -> Name,OnClick);
    }
  else
    fprintf (cppfile,",NULL,0");

  // Layout
  if (Layout != NULL)
    {
      if (strcmp (Layout,"blGlyphLeft") == 0)
        fprintf (cppfile,",ICON_BEFORE_TEXT|");
      else
      if (strcmp (Layout,"blGlyphRight") == 0)
        fprintf (cppfile,",ICON_AFTER_TEXT|");
      else
      if (strcmp (Layout,"blGlyphTop") == 0)
        fprintf (cppfile,",ICON_ABOVE_TEXT|");
      else
      if (strcmp (Layout,"blGlyphBottom") == 0)
        fprintf (cppfile,",ICON_BELOW_TEXT|");
    }
  else
    fprintf (cppfile,",ICON_BEFORE_TEXT|");

  fprintf (cppfile,"FRAME_NORMAL|LAYOUT_FIX_X|LAYOUT_FIX_Y|LAYOUT_FIX_WIDTH|LAYOUT_FIX_HEIGHT,");
  fprintf (cppfile,"%i,%i,%i,%i,0,0,0,0);\n",Left,Top,Width,Height);

  // Enabled
  if (Enabled != NULL && strcmp (Enabled,"False") == 0)
    {
      fprintf (cppfile,"  %s -> disable ();\n",Stack -> Name);
    }

  // Font Color

  if (FontColor != NULL && strlen (GetColor (FontColor)) > 0)
    {
      fprintf (cppfile,"  %s -> setTextColor (%s);\n",Stack -> Name,GetColor (FontColor));
    }

  // Font
  if (FontHeight != 0 && FontName != NULL)
    {
      fprintf (cppfile,"  %s -> setFont (new FXFont (getApp(),\"%s\",%i",Stack -> Name,FontName,(int)((-FontHeight * 72) / 96));

      bool Bold = false;
      bool Italic = false;
      while (!Empty (FontStyle))
        {
          if (strcmp (FontStyle -> Name,"fsBold") == 0)
            Bold = true;
          else
          if (strcmp (FontStyle -> Name,"fsItalic") == 0)
            Italic = true;
          Pop (FontStyle);
        }

      // Bold
      if (Bold == true)
        fprintf (cppfile,",FONTWEIGHT_BOLD");
      else
        fprintf (cppfile,",FONTWEIGHT_NORMAL");

      // Italic
      if (Italic == true)
        fprintf (cppfile,",FONTSLANT_ITALIC");
      else
        fprintf (cppfile,",FONTSLANT_REGULAR");

      // FontCharset
      if (FontCharset != NULL)
        fprintf (cppfile,",%s));\n",GetFontCharset (FontCharset));
      else
        fprintf (cppfile,"));\n");
    }

  // Cursor
  if (Cursor != NULL && strlen (GetCursor (Cursor)) > 0)
    {
      fprintf (cppfile,"  %s -> setDefaultCursor(getApp () -> getDefaultCursor(%s));\n",Stack -> Name,GetCursor (Cursor));
    }

  // one empty line
  fprintf (cppfile,"\n");

  // Event - OnClick
  if (OnClick != NULL)
    {
      // EventFunction
      Push (EventsFunction,OnClick);

      // Message Type
      Push (MessageType,"SEL_COMMAND");

      // MessageID
      char MsgID [512];
      sprintf (MsgID,"ID_%s",Stack -> Name);
      Push (MessageID,MsgID);
    }

  // Event - OnKeyDown
  if (OnKeyDown != NULL)
    {
      // EventFunction
      Push (EventsFunction,OnKeyDown);

      // Message Type
      Push (MessageType,"SEL_KEYPRESS");

      // MessageID
      char MsgID [512];
      sprintf (MsgID,"ID_%s",Stack -> Name);
      Push (MessageID,MsgID);
    }

  // Event - OnKeyUp
  if (OnKeyUp != NULL)
    {
      // EventFunction
      Push (EventsFunction,OnKeyUp);

      // Message Type
      Push (MessageType,"SEL_KEYRELEASE");

      // MessageID
      char MsgID [512];
      sprintf (MsgID,"ID_%s",Stack -> Name);
      Push (MessageID,MsgID);
    }

  // clear
  delete [] Caption;
  delete [] FontColor;
  delete [] Hint;
  delete [] FontCharset;
  delete [] FontName;
  delete [] Enabled;
  delete [] Cursor;
  delete [] GlyphData;
  delete [] Layout;
  delete [] Kind;
  delete [] OnClick;
  delete [] OnKeyDown;
  delete [] OnKeyUp;
}
